#include <stdlib.h>
#include <iostream>
#include <mathimf.h> 
#include "gdal.h"
#include "ogr_spatialref.h"

double nan(){
	return (double)0/0.0;
}


int main(){
	double *x, *y;
	int npts = 5;
	OGRSpatialReference *oSrcSRS = new OGRSpatialReference();
	OGRSpatialReference *oDstSRS = new OGRSpatialReference(); 
	OGRCoordinateTransformation *poCT;
	int *res;

	x = (double *)calloc(npts,sizeof(double));
	y = (double *)calloc(npts,sizeof(double));
	res = (int *)calloc(npts,sizeof(int));

	x[0] = -8.9500572;
	x[1] = -8.9500877;
	x[2] = nan();
	x[3] = -8.9471580;
	x[4] = -8.9471580;

	y[0] = 3.7000031e+001;
	y[1] = 3.7000000e+001;
	y[2] = nan();
	y[3] = 3.7000000e+001;
	y[4] = 3.7000046e+001;
	
	std::cout << "Coordinates before transformation:" << std::endl;
	for (int i = 0; i < npts; i++)
		std::cout << "x: " << x[i] << " y: " << y[i] << " -> is x nan: " << isnan(x[i]) << " is y nan: " << isnan(y[i])<< std::endl;

	oSrcSRS->SetWellKnownGeogCS( "WGS84" );
	oDstSRS->importFromProj4("+proj=utm +zone=29 +datum=wgs84");
	poCT = OGRCreateCoordinateTransformation( oSrcSRS, oDstSRS );

	//poCT->Transform( npts, x, y );
	poCT->TransformEx(npts,x,y,NULL,res);

	std::cout << std::endl << "Coordinates after transformation:" << std::endl;
	for (int i = 0; i < npts; i++)
		std::cout << "x: " << x[i] << " y: " << y[i] << " -> is x nan: " << isnan(x[i]) << " is y nan: " << isnan(y[i]) << std::endl;
		//std::cout << "x: " << x[i] << " y: " << y[i] << " is x nan: " << isnan(x[i]) << " is y nan: " << isnan(y[i]) << " res: " << res[i] << std::endl;

    return 0;
}